#include <stdio.h>
#include "stereo.h"

using namespace cv;
using namespace std;


extern "C"
int cudaCensus(cv::Mat& left_img, cv::Mat& right_img, unsigned short *dsi);
extern "C"
void cudaInit();

//#define  USE_CUDA


void StereoTest(void)
{
    const int disp_num = 64;

    cudaInit();
	
    Mat imgLeft  = imread("1-L.png",0);
    Mat imgRight= imread("1-R.png",0);
    cv::Size img_size;
    img_size.width = 1024;
    img_size.height = 400;
    cv::resize(imgLeft, imgLeft, img_size);
    cv::resize(imgRight, imgRight, img_size);
    int height = imgLeft.rows;
    int width  = imgLeft.cols;
    u16 *dsi      =(u16 *)malloc(sizeof(int)*width*height*disp_num);
    u16 *dsiAgg=(u16 *)malloc(sizeof(int)*width*height*disp_num);
    cout << "runing..." <<endl;

#ifdef USE_CUDA
    memset(dsiAgg, 0, height * width * disp_num* sizeof(unsigned short));
    cudaCensus(imgLeft, imgRight, dsiAgg);
#else
    clock_t start = clock();
    Census((uchar *)imgLeft.data, (uchar *)imgRight.data, height, width, disp_num, dsi);
    printf("time of census: %.3f s\n", (double)(clock()-start)/CLOCKS_PER_SEC);

    clock_t TransposeDSI_clock = clock();
    TransposeDSI(width, height, disp_num, dsiAgg, dsi);
    printf("time of TransposeDSI: %.3f s\n", (double)(clock()-TransposeDSI_clock)/CLOCKS_PER_SEC);

    printf("total time: %.3f s\n\n\n", (double)(clock()-start)/CLOCKS_PER_SEC);
#endif

	free(dsi);
    free(dsiAgg);
}

int main(int argc, char *argv[])
{	
    StereoTest();

	return 0;
}
